VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "HS256 Demo"
   ClientHeight    =   4770
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   8085
   BeginProperty Font 
      Name            =   "Microsoft Sans Serif"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   4770
   ScaleWidth      =   8085
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtSignature 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   0
      TabIndex        =   7
      Top             =   4380
      Width           =   8055
   End
   Begin VB.CommandButton cmdSignIt 
      Caption         =   "Sign It"
      Height          =   495
      Left            =   3480
      TabIndex        =   6
      Top             =   3600
      Width           =   1215
   End
   Begin VB.TextBox txtAWSSecretKey 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      IMEMode         =   3  'DISABLE
      Left            =   0
      PasswordChar    =   ""
      TabIndex        =   4
      Text            =   "kWcrlUX5JEDGM/LtmEENI/aVmYvHNif5zB+d9+ct"
      Top             =   3180
      Width           =   8055
   End
   Begin VB.TextBox txtAWSKeyID 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   0
      TabIndex        =   2
      Text            =   "022QF06E7MXBSH9DHM02"
      Top             =   2520
      Width           =   8055
   End
   Begin VB.TextBox txtStringToSign 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1815
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Text            =   "Form1.frx":0000
      Top             =   360
      Width           =   8055
   End
   Begin VB.Label Label4 
      Caption         =   "Signature:"
      Height          =   255
      Left            =   60
      TabIndex        =   8
      Top             =   4080
      Width           =   2595
   End
   Begin VB.Label Label3 
      Caption         =   "Your AWS Secret Access Key:"
      Height          =   255
      Left            =   60
      TabIndex        =   5
      Top             =   2880
      Width           =   2595
   End
   Begin VB.Label Label2 
      Caption         =   "Your AWS Access Key ID:"
      Height          =   255
      Left            =   60
      TabIndex        =   3
      Top             =   2220
      Width           =   2595
   End
   Begin VB.Label Label1 
      Caption         =   "String to sign:"
      Height          =   255
      Left            =   60
      TabIndex        =   1
      Top             =   60
      Width           =   2595
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdSignIt_Click()
    Dim HS256 As HS256
    
    Set HS256 = New HS256
    '--------------------------------------------------------------
    'Convert the "string to sign" from the textbox format to the
    'actual format used:
    Dim StringToSign As String
    
    StringToSign = Replace$(txtStringToSign.Text, _
                            "<Your AWS Access Key ID>", _
                            txtAWSKeyID.Text)
    StringToSign = Replace$(StringToSign, vbNewLine, "")
    StringToSign = Replace$(StringToSign, "\n", vbLf)
    'This isn't entirely realistic because in real software using
    'AWS the StringToSign would have been built up by:
    '   1. Setting up all of your headers
    '   2. Canonicalizing them, which VB6 users involves:
    '       a. Converting the headers to UTF-8.
    '       b. Sorting your list of headers in ascending order
    '          using the header key as the sort key.
    '       c. Percent-encoding each header value according to
    '          the AWS rules.
    '       d. Joining each header's key and value with an = sign.
    '       e. Joining the header-pair strings with & signs.
    '   3. Joining:
    '           o The HTTP Verb
    '           o LCase$(Host Header)
    '           o The Request URI
    '           o The string from step 2 above
    '      ... all together with "ASCII newline" which is really
    '      UTF-8 but *nix people seem to try to get away with
    '      using them interchangably because most of the time
    '      they luck out and the values are the same.
    '
    '      I AM ASSUMING they mean LF when they say "newline"
    '      even though by rights (and HTTP rules) they should
    '      never be pulling such a stunt.  This should be CR/LF
    '      but I suspect it isn't here!
    '
    '      This point would be worth nailing down, since it is
    '      *critical*.  You might try the developer forums at
    '      AWS to get a firm answer on this.
    '--------------------------------------------------------------
    'Ok, in any case we have a simulated StringToSign but as I
    'said it is supposed to be UTF-8.  Deal with that here:
    Dim bytStringToSign() As Byte
    
    bytStringToSign = HS256.ToUTF8(StringToSign)
    StringToSign = ""
    '--------------------------------------------------------------
    'Now we need to convert the Secret Key to UTF-8.  Once again
    'a large part of the time this is the same as ASCII, which
    'much of the time is the same as ANSI.  However any characters
    'beyond the printable "Roman" symbols of 7-bit ASCII are a
    'risk so just do it this way:
    Dim bytSecretKey() As Byte
    
    bytSecretKey = HS256.ToUTF8(txtAWSSecretKey.Text)
    '--------------------------------------------------------------
    'Initialize the HMAC with our Key:
    HS256.InitHmac bytSecretKey
    Erase bytSecretKey
    '--------------------------------------------------------------
    'Create the Signature hash:
    Dim bytSignature() As Byte
    
    bytSignature = HS256.HmacSha256(bytStringToSign)
    Erase bytStringToSign
    '--------------------------------------------------------------
    'Convert the Signature to Base64:
    Dim Base64Signature As String
    
    Base64Signature = HS256.Encode(bytSignature, edfBase64, efNoFolding)
    Erase bytSignature
    txtSignature.Text = Base64Signature
    '--------------------------------------------------------------
    'There *is* one more step: URLEncode the Base64 Signature
    'according to RFC 3986 rules.  However as far as I know  both
    'MSXML2.XMLHTTP and WinHttp.WinHttpRequest take care of this
    'when you set your final Signature header using their
    '.setRequestHeader methods.
    '
    'Those are the most common ways a VB6 programmer might access a
    'REST service, so I never added a URLEncode3386 method to HS256.
    '
    'Looking back now, an AWS %-encoding method might have been a
    'handy addition but people use my HS256 for other services
    'besides AWS.
End Sub
